#include <stdio.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

main(int argc,char *argv[])
{
  int fkt, fd, pos;
  struct flock lockarea;
  /* File zum Lesen und Schreiben eroeffnen 
   Operationen: w   schreiben
                r   lesen
  */

  if ( argc !=4 ) {
      fprintf(stderr,"use: %s [r|w] <filename> <offset>\n",argv[0]);
      exit(1);
  }
  if ( ! strcmp(argv[1],"r") )
       fkt=F_RDLCK;
  else 
     if ( ! strcmp(argv[1],"w")) fkt=F_WRLCK;
     else { fprintf(stderr,"use: %s [r|w] <filename> <offset>\n",argv[0]);
            exit(2);
     }
  sscanf(argv[3],"%d",&pos); 
  if ((fd=open(argv[2],O_RDWR))<0) {
      err_sys("open-error ");
  }
  lockarea.l_type=fkt;
  lockarea.l_whence=SEEK_SET;
  lockarea.l_start=pos;
  lockarea.l_len=100;
  if ( fcntl(fd,F_SETLK,&lockarea) < 0 ) {
     printf("%d: kein sofortiges '%s'-fcntl-lock fuer '%s(%d:%d)' moeglich\n",getpid(),argv[1],argv[2],pos,100);
     printf("%d: jetz '%s'-fcntl-lock fuer '%s(%d:%d)' mit warten\n",getpid(),argv[1],argv[2],pos,100);
     if ( fcntl(fd,F_SETLKW,&lockarea) < 0 ) {
       err_sys("fcntl-error ");
     }
  }
  printf("%d: '%s'-fcntl-lock fuer '%s(%d:%d)' erfolgreich, jetzt zugriff\n",getpid(),argv[1],argv[2],pos,100);
  pause();
}
