/* su_sock.c  - Server for udp-socket */

#include "inet.h"

void talk(int sockfd,struct sockaddr *pcli_addr,int maxln)
{ 
    int n, clilen = maxln;
    char sendline[MAXLINE];

    while((n=recvfrom(sockfd,sendline,MAXLINE,0,
                                   pcli_addr,(socklen_t *) &clilen)) > 0) {
        fprintf(stderr,"Client:%s\n",inet_ntoa( ((struct sockaddr_in *)pcli_addr)->sin_addr));
        write(1,sendline,n);
        write(1,"s> ",3);
        if ((n=read(0,sendline,MAXLINE)) <= 0) break;
        if (sendto(sockfd,sendline,n,0,pcli_addr,clilen) !=n)
              break;
    }
}
int main(int argc, char *argv[])
{
    int sockfd;
    struct sockaddr_in  cli_addr, serv_addr;
    if (( sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        fprintf(stderr, "su_sock: can't open datagram socket\n");
        exit(-1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(SERV_UDP_PORT);
    if (bind(sockfd, (struct sockaddr *) &serv_addr,
             sizeof(serv_addr)) < 0){
        fprintf(stderr,"su_sock: can't bind local address\n");
        exit(-2);
    }
    talk(sockfd,(struct sockaddr *) &cli_addr,sizeof(cli_addr));
    exit(0);
}
