
/* udptd.c  - Server for udp-Test*/

#include "inet.h"
#include <sys/time.h>

void talk(int sockfd,struct sockaddr *pcli_addr,int maxln)
{ 
   int clilen = maxln;
   long n,lgt,count,ncount,ist=0,aktblkn;
   float sec;
   long err,blks,fblocks;
   struct timeval tv1,tv2;
   struct timezone tz1,tz2;
   struct { long blknr;
            long value;
          } cntblock;
   struct { long blknr;
            char recline[65000];
          } block;
   /* lesen Blocklaenge*/
   n=recvfrom(sockfd,&cntblock,sizeof(cntblock),0,pcli_addr,(socklen_t *) &clilen);
   if (n!=8) return; 
   if (cntblock.blknr!=0) return; 
   if (cntblock.value==0 ) return;
   lgt=ntohl(cntblock.value);
   n=sendto(sockfd,&cntblock,sizeof(cntblock),0,pcli_addr,clilen); 
   /* lesen Blockanzahl */
   n=recvfrom(sockfd,&cntblock,sizeof(cntblock),0,pcli_addr,(socklen_t *) &clilen);
   if (n!=8) return; 
   if (cntblock.blknr!=0) return; 
   if (cntblock.value==0 ) return;
   count=ntohl(cntblock.value);
   printf("Blocklaenge: %ld, Bloecke: %ld\n",lgt,count);
   n=sendto(sockfd,&cntblock,sizeof(cntblock),0,pcli_addr,clilen); 
   gettimeofday(&tv1,&tz1);
   ncount=1;
   err=0;blks=0; fblocks=0;
   while((n=recvfrom(sockfd, &block,sizeof(block),0,
                     pcli_addr,(socklen_t *) &clilen)) > 0) {
         aktblkn=ntohl(block.blknr);
         if (n == 4 && aktblkn==0 ) {
                 break;
         }
         if (n != lgt+4 ) {
            printf("Lesefehler: Soll: %ld, Ist: %ld\n",lgt,n);
         } 
         ist=aktblkn;
         if (ist != ncount) {
            /*printf("Blockfolgefehler! Soll: %ld, Ist: %ld\n",ncount,ist);*/
	    err++;
	    fblocks=fblocks+ist-ncount;
            ncount = ist;
         } 
	 sendto(sockfd,&block,4,0,pcli_addr,clilen);
	 blks++;
         ncount++;
	 if (ncount > count ) break;
   }
   ncount--;
   gettimeofday(&tv2,&tz2);
   sec=((tv2.tv_sec-tv1.tv_sec)*1000000+(tv2.tv_usec-tv1.tv_usec))/1000000.0;
   fprintf(stderr,"Duration: %f Sekunden\n",sec);
   fprintf(stderr,"KBytes/Sekunde: %f\n",((blks*(lgt+4))/1024)/sec);
   fprintf(stderr,"Blocks: %ld, Blockfolgefehler: %ld, fehlende Blocks:%ld\n",blks,err,fblocks);
   printf("letzte Blocknummer: %ld\nready\n\n",ncount);
}
int main(int argc, char *argv[])
{
    int sockfd;
    struct sockaddr_in  cli_addr, serv_addr;
    if (( sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        fprintf(stderr, "su_sock: can't open datagram socket\n");
        exit(-1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(SERV_UDP_PORT);
    if (bind(sockfd, (struct sockaddr *) &serv_addr,
             sizeof(serv_addr)) < 0){
        fprintf(stderr,"su_sock: can't bind local address\n");
        exit(-2);
    }
    do
        talk(sockfd,(struct sockaddr *) &cli_addr,sizeof(cli_addr));
    while (1);
    exit(0);
}
